[Please READ this before you start]

Instruction before running / start this project:
1) Before installing, please specify database url in .env file. OR you can use mine but you need internet connections
2) Install all required things, use install.bat (double click it like executable)
2a) OR you can just run these command below (sequentially)
2b) `npm i --production=false`
2c) `npx prisma migrate reset --schema=./models/schema.prisma -f`
2d) `npx prisma db pull --schema=./models/schema.prisma`
2e) `npx prisma generate --schema=./models/schema.prisma`
2f) Installation will take a while, so please be patient.
2g) Make sure Installation is successful or done properly.
3) Then you can run with run.bat (double click it like executable), OR you can just do `npm start`

Instruction before doing unit test:
1) Install all required things, follow the instruction above
2) Open deploy-migration.bat to reset all data inside database
3) Open unit-test.bat (double click it like executable)
3a) OR you can just run these command below
3b) `npx jest --runTestsByPath=tests`
4) Unit test will take a while, so please be patient.

Instruction before using gitlab CI/CD:
1) Go to gitlab project settings -> CI/CD
2) Expand variables -> Add variables, and add these variables (key=value)
2a) DATABASE_URL=postgresql://randomuser:randompassword@postgres:5432/mydb?schema=public
2b) HEROKU_API_KEY=REPLACE_WITH_YOUR_KEY
2c) HEROKU_APP_NAME=REPLACE_WITH_YOUR_APP_NAME
2d) POSTGRES_DB=mydb
2e) POSTGRES_USER=randomuser
2f) POSTGRES_PASSWORD=randompassword
2g) AUTH_METHOD=db
3) Done, you can now push your code to gitlab and CI/CD runner will run without any problem

Instruction before using github CI/CD:
1) Go to github repo settings -> Secrets -> Actions
2) Add these variables (key=value)
2a) DATABASE_URL=postgresql://randomuser:randompassword@postgres:5432/mydb?schema=public
2b) HEROKU_API_KEY=REPLACE_WITH_YOUR_KEY
2c) HEROKU_APP_NAME=REPLACE_WITH_YOUR_APP_NAME
2d) POSTGRES_DB=mydb
2e) POSTGRES_USER=randomuser
2f) POSTGRES_PASSWORD=randompassword
2g) AUTH_METHOD=db
3) Done, you can now push your code to gitlab and CI/CD runner will run without any problem

Demo App: https://aabbbccccc.herokuapp.com/

Design Pattern: MVC with Router and auto-generated Models
Folder Structure:
  - root (this folder)
    - bin
    - controllers
      - API
      - web
    - middlewares
    - models
    - public
      - css
      - js
      - images
    - routes
    - views

Folder Structure Explanation:
  - bin:
    > contains all the executables (you don't need to touch this folder)
  - controllers:
    > contains all the controllers
    > separated by API and web
  - middlewares:
    > contains all the middlewares
    > register your middlewares here inside function in index.js
  - models:
    > contains all the models (you don't need to touch this folder, but you can add your models here)
    > is automatically generated by prisma (see explanation below)
  - public:
    > contains all the static files
    > these files are served by the server
  - routes:
    > contains all the routes
    > register your API routes in api.js
    > register your web routes in web.js
  - views:
    > contains all the views

Prisma auto-generated models explanation:
  - prisma automatically generates a model for each table in your database when you run `npx prisma pull`
  - the model is automatically generated by prisma (depends on your database)
  - generated models are stored inside prisma.schema in models folder
  - more https://www.prisma.io/docs/getting-started
